package dev.micle.totemofreviving.setup;

import dev.micle.totemofreviving.TotemOfReviving;
import dev.micle.totemofreviving.event.RecipeUpdateEventHandler;
import net.minecraft.item.Item;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.IForgeRegistry;
import net.minecraftforge.registries.IForgeRegistryEntry;

public class Registration {
    public static final DeferredRegister<Item> ITEMS = create(ForgeRegistries.ITEMS);

    public static void register() {
        IEventBus modEventBus = FMLJavaModLoadingContext.get().getModEventBus();
		
        ITEMS.register(modEventBus);
        ModItems.register();
		
		modEventBus.register(new RecipeUpdateEventHandler.ModBus());
	
		MinecraftForge.EVENT_BUS.register(new RecipeUpdateEventHandler.EventBus());
    }
	
	private static <T extends IForgeRegistryEntry<T>> DeferredRegister<T> create(IForgeRegistry<T> registry) {
		return DeferredRegister.create(registry, TotemOfReviving.MOD_ID);
	}
}
